VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOption"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @Option   : Store the options.                 #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### API
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

'### Constants
Private Const cFILE_INI                   As String = "\settings.ini"

'### Constants (Defaults)
Private Const m_Def_bFirstStart           As Boolean = True
Private Const m_Def_bOption_BlendEffects  As Boolean = True
Private Const m_Def_bOption_CrossVolume   As Boolean = False
Private Const m_Def_bOption_EnableTime1   As Boolean = True
Private Const m_Def_bOption_EnableTime2   As Boolean = True
Private Const m_Def_bOption_ModePause     As Boolean = True
Private Const m_Def_bOption_RunOnce       As Boolean = False
Private Const m_Def_bOption_SendMail      As Boolean = False
Private Const m_Def_bOption_ShowEndInfo   As Boolean = True
Private Const m_Def_bOption_ShowErrorInfo As Boolean = True
Private Const m_Def_bOption_ShowTrayInfo  As Boolean = True
Private Const m_Def_bOption_ShutDown      As Boolean = False
Private Const m_Def_bOption_StartActivate As Boolean = False
Private Const m_Def_bOption_StartToTray   As Boolean = False
Private Const m_Def_bOption_StartWithWin  As Boolean = False
Private Const m_Def_bOption_SysTray       As Boolean = False
Private Const m_Def_iOption_Hour1         As Integer = 0
Private Const m_Def_iOption_Hour2         As Integer = 0
Private Const m_Def_iOption_Minute1       As Integer = 0
Private Const m_Def_iOption_Minute2       As Integer = 0
Private Const m_Def_lOption_PlayerIndex   As Long = 0
Private Const m_Def_sOption_MailAddress   As String = ""

'### Variables
Private m_bFirstStart                     As Boolean
Private m_bOption_BlendEffects            As Boolean
Private m_bOption_CrossVolume             As Boolean
Private m_bOption_EnableTime1             As Boolean
Private m_bOption_EnableTime2             As Boolean
Private m_bOption_ModePause               As Boolean
Private m_bOption_RunOnce                 As Boolean
Private m_bOption_SendMail                As Boolean
Private m_bOption_ShowEndInfo             As Boolean
Private m_bOption_ShowErrorInfo           As Boolean
Private m_bOption_ShowTrayInfo            As Boolean
Private m_bOption_ShutDown                As Boolean
Private m_bOption_StartActivate           As Boolean
Private m_bOption_StartToTray             As Boolean
Private m_bOption_StartWithWin            As Boolean
Private m_bOption_SysTray                 As Boolean
Private m_iOption_Hour1                   As Integer
Private m_iOption_Hour2                   As Integer
Private m_iOption_Minute1                 As Integer
Private m_iOption_Minute2                 As Integer
Private m_lOption_PlayerIndex             As Long
Private m_sOption_MailAddress             As String



'##################################################
'###                  EVENTS                    ###
'##################################################

Private Sub Class_Initialize()
'### @Option: Called if somebody create a new instance of this class

    'Set the default values
    Let m_bFirstStart = m_Def_bFirstStart
    Let m_bOption_BlendEffects = m_Def_bOption_BlendEffects
    Let m_bOption_CrossVolume = m_Def_bOption_CrossVolume
    Let m_bOption_EnableTime1 = m_Def_bOption_EnableTime1
    Let m_bOption_EnableTime2 = m_Def_bOption_EnableTime2
    Let m_bOption_ModePause = m_Def_bOption_ModePause
    Let m_bOption_RunOnce = m_Def_bOption_RunOnce
    Let m_bOption_SendMail = m_Def_bOption_SendMail
    Let m_bOption_ShowEndInfo = m_Def_bOption_ShowEndInfo
    Let m_bOption_ShowErrorInfo = m_Def_bOption_ShowErrorInfo
    Let m_bOption_ShowTrayInfo = m_Def_bOption_ShowTrayInfo
    Let m_bOption_ShutDown = m_Def_bOption_ShutDown
    Let m_bOption_StartActivate = m_Def_bOption_StartActivate
    Let m_bOption_StartToTray = m_Def_bOption_StartToTray
    Let m_bOption_StartWithWin = m_Def_bOption_StartWithWin
    Let m_bOption_SysTray = m_Def_bOption_SysTray
    Let m_iOption_Hour1 = m_Def_iOption_Hour1
    Let m_iOption_Hour2 = m_Def_iOption_Hour2
    Let m_iOption_Minute1 = m_Def_iOption_Minute1
    Let m_iOption_Minute2 = m_Def_iOption_Minute2
    Let m_lOption_PlayerIndex = m_Def_lOption_PlayerIndex
    Let m_sOption_MailAddress = m_Def_sOption_MailAddress

End Sub


'##################################################
'###                 METHODS                    ###
'##################################################

Public Sub sSettings_Load()
'### @info: Load the settings from the INI file

    'Variables
    Dim sValue As String

    'Check if it is the first start
   Let m_bFirstStart = Not CSystem.fFileExist(App.Path & cFILE_INI)

    'Load the info to the class
    sValue = fReadValue("Options", "BlendEffects")
    If (Len(sValue) > 0) Then
        Let pOption_BlendEffects = CBool(Val(sValue) = 1)
    Else
        Let pOption_BlendEffects = m_Def_bOption_BlendEffects
    End If
    '---
    sValue = fReadValue("Options", "CrossVolume")
    If (Len(sValue) > 0) Then
        Let pOption_CrossVolume = CBool(Val(sValue) = 1)
    Else
        Let pOption_CrossVolume = m_Def_bOption_CrossVolume
    End If
    '---
    sValue = fReadValue("Options", "EnableTime1")
    If (Len(sValue) > 0) Then
        Let pOption_EnableTime1 = CBool(Val(sValue) = 1)
    Else
        Let pOption_EnableTime1 = m_Def_bOption_EnableTime1
    End If
    '---
    sValue = fReadValue("Options", "EnableTime2")
    If (Len(sValue) > 0) Then
        Let pOption_EnableTime2 = CBool(Val(sValue) = 1)
    Else
        Let pOption_EnableTime2 = m_Def_bOption_EnableTime2
    End If
    '---
    sValue = fReadValue("Options", "Hour1")
    If (Len(sValue) > 0) Then
        Let pOption_Hour1 = CLng(Val(sValue))
    Else
        Let pOption_Hour1 = 0
    End If
    '---
    sValue = fReadValue("Options", "Hour2")
    If (Len(sValue) > 0) Then
        Let pOption_Hour2 = CLng(Val(sValue))
    Else
        Let pOption_Hour2 = 0
    End If
    '---
    sValue = fReadValue("Options", "MailAddress")
    If (Len(sValue) > 0) Then
        Let pOption_MailAddress = Left(sValue, 64)
    Else
        Let pOption_MailAddress = m_Def_sOption_MailAddress
    End If
    '---
    sValue = fReadValue("Options", "Minute1")
    If (Len(sValue) > 0) Then
        Let pOption_Minute1 = CLng(Val(sValue))
    Else
        Let pOption_Minute1 = 0
    End If
    '---
    sValue = fReadValue("Options", "Minute2")
    If (Len(sValue) > 0) Then
        Let pOption_Minute2 = CLng(Val(sValue))
    Else
        Let pOption_Minute2 = 0
    End If
    '---
    sValue = fReadValue("Options", "ModePause")
    If (Len(sValue) > 0) Then
        Let pOption_ModePause = CBool(Val(sValue) = 1)
    Else
        Let pOption_ModePause = m_Def_bOption_ModePause
    End If
    '---
    sValue = fReadValue("Options", "PlayerIndex")
    If (Len(sValue) > 0) Then
        Let pOption_PlayerIndex = CLng(Val(sValue))
    Else
        Let pOption_PlayerIndex = 0
    End If
    '---
    sValue = fReadValue("Options", "RunOnce")
    If (Len(sValue) > 0) Then
        Let pOption_RunOnce = CBool(Val(sValue) = 1)
    Else
        Let pOption_RunOnce = m_Def_bOption_RunOnce
    End If
    '---
    sValue = fReadValue("Options", "SendMail")
    If (Len(sValue) > 0) Then
        Let pOption_SendMail = CBool(Val(sValue) = 1)
    Else
        Let pOption_SendMail = m_Def_bOption_SendMail
    End If
    '---
    sValue = fReadValue("Options", "ShowEndInfo")
    If (Len(sValue) > 0) Then
        Let pOption_ShowEndInfo = CBool(Val(sValue) = 1)
    Else
        Let pOption_ShowEndInfo = m_Def_bOption_ShowEndInfo
    End If
    '---
    sValue = fReadValue("Options", "ShowErrorInfo")
    If (Len(sValue) > 0) Then
        Let pOption_ShowErrorInfo = CBool(Val(sValue) = 1)
    Else
        Let pOption_ShowErrorInfo = m_Def_bOption_ShowErrorInfo
    End If
    '---
    sValue = fReadValue("Options", "ShowTrayInfo")
    If (Len(sValue) > 0) Then
        Let pOption_ShowTrayInfo = CBool(Val(sValue) = 1)
    Else
        Let pOption_ShowTrayInfo = m_Def_bOption_ShowTrayInfo
    End If
    '---
    sValue = fReadValue("Options", "ShutDown")
    If (Len(sValue) > 0) Then
        Let pOption_ShutDown = CBool(Val(sValue) = 1)
    Else
        Let pOption_ShutDown = m_Def_bOption_ShutDown
    End If
    '---
    sValue = fReadValue("Options", "StartActivate")
    If (Len(sValue) > 0) Then
        Let pOption_StartActivate = CBool(Val(sValue) = 1)
    Else
        Let pOption_StartActivate = m_Def_bOption_StartActivate
    End If
    '---
    sValue = fReadValue("Options", "StartToTray")
    If (Len(sValue) > 0) Then
        Let pOption_StartToTray = CBool(Val(sValue) = 1)
    Else
        Let pOption_StartToTray = m_Def_bOption_StartToTray
    End If
    '---
    sValue = fReadValue("Options", "StartWithWin")
    If (Len(sValue) > 0) Then
        Let pOption_StartWithWin = CBool(Val(sValue) = 1)
    Else
        Let pOption_StartWithWin = m_Def_bOption_StartWithWin
    End If
    '---
    sValue = fReadValue("Options", "SysTray")
    If (Len(sValue) > 0) Then
        Let pOption_SysTray = CBool(Val(sValue) = 1)
    Else
        Let pOption_SysTray = m_Def_bOption_SysTray
    End If
    
End Sub

Public Sub sSettings_Save()
'### @info: Save the settings to the INI file
    
    'Save the settings
    Call fWriteValue("Options", "BlendEffects", IIf(pOption_BlendEffects, "1", "0"))
    Call fWriteValue("Options", "CrossVolume", IIf(pOption_CrossVolume, "1", "0"))
    Call fWriteValue("Options", "EnableTime1", IIf(pOption_EnableTime1, "1", "0"))
    Call fWriteValue("Options", "EnableTime2", IIf(pOption_EnableTime2, "1", "0"))
    Call fWriteValue("Options", "Hour1", CStr(pOption_Hour1))
    Call fWriteValue("Options", "Hour2", CStr(pOption_Hour2))
    Call fWriteValue("Options", "MailAddress", pOption_MailAddress)
    Call fWriteValue("Options", "Minute1", CStr(pOption_Minute1))
    Call fWriteValue("Options", "Minute2", CStr(pOption_Minute2))
    Call fWriteValue("Options", "ModePause", IIf(pOption_ModePause, "1", "0"))
    Call fWriteValue("Options", "PlayerIndex", CStr(pOption_PlayerIndex))
    Call fWriteValue("Options", "RunOnce", IIf(pOption_RunOnce, "1", "0"))
    Call fWriteValue("Options", "SendMail", IIf(pOption_SendMail, "1", "0"))
    Call fWriteValue("Options", "ShowEndInfo", IIf(pOption_ShowEndInfo, "1", "0"))
    Call fWriteValue("Options", "ShowErrorInfo", IIf(pOption_ShowEndInfo, "1", "0"))
    Call fWriteValue("Options", "ShowTrayInfo", IIf(pOption_ShowTrayInfo, "1", "0"))
    Call fWriteValue("Options", "ShutDown", IIf(pOption_ShutDown, "1", "0"))
    Call fWriteValue("Options", "StartActivate", IIf(pOption_StartActivate, "1", "0"))
    Call fWriteValue("Options", "StartToTray", IIf(pOption_StartToTray, "1", "0"))
    Call fWriteValue("Options", "StartWithWin", IIf(pOption_StartWithWin, "1", "0"))
    Call fWriteValue("Options", "SysTray", IIf(pOption_SysTray, "1", "0"))

End Sub

Public Function fReadValue(ByVal sSection As String, ByVal sKey As String, _
    Optional ByVal sFilePath As String = "{ini}") As String
'### @Option: Write a new part to an INI file
    
'Ignore all errors
On Error Resume Next

    'Variables
    Dim lResult As Long
    Dim sResult As String * 255

    'Read the value
    If (sFilePath = "{ini}") Then Let sFilePath = App.Path & cFILE_INI
    Let lResult = GetPrivateProfileString(sSection, sKey, "", sResult, 255, sFilePath)
    
    'Return the value
    If (lResult) Then fReadValue = Left(sResult, lResult)

End Function

Public Function fWriteValue(ByVal sSection As String, ByVal sKey As String, ByVal sValue As String, _
    Optional ByVal sFilePath As String = "{ini}") As Boolean
'### @Option: Write a new part to an INI file
    
'Ignore all errors
On Error Resume Next

    'Variables
    Dim lResult As Long
    
    'Write the value
    If (sFilePath = "{ini}") Then Let sFilePath = App.Path & cFILE_INI
    Let lResult = WritePrivateProfileString(sSection, sKey, sValue, sFilePath)
    
    'Operation successful or not
    fWriteValue = (lResult)

End Function



'##################################################
'###                PROPERTIES                  ###
'##################################################

Public Property Get pFirstStart() As Boolean

    'Return the version
    Let pFirstStart = m_bFirstStart

End Property
'##################################################
Public Property Get pOption_BlendEffects() As Boolean

    'Return the version
    Let pOption_BlendEffects = m_bOption_BlendEffects
    
End Property
'###########
Public Property Let pOption_BlendEffects(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_BlendEffects = bNewValue

End Property
'##################################################
Public Property Get pOption_CrossVolume() As Boolean

    'Return the version
    Let pOption_CrossVolume = m_bOption_CrossVolume

End Property
'###########
Public Property Let pOption_CrossVolume(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_CrossVolume = bNewValue

End Property
'##################################################
Public Property Get pOption_EnableTime1() As Boolean

    'Return the version
    Let pOption_EnableTime1 = m_bOption_EnableTime1

End Property
'###########
Public Property Let pOption_EnableTime1(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_EnableTime1 = bNewValue

End Property
'##################################################
Public Property Get pOption_EnableTime2() As Boolean

    'Return the version
    Let pOption_EnableTime2 = m_bOption_EnableTime2

End Property
'###########
Public Property Let pOption_EnableTime2(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_EnableTime2 = bNewValue

End Property
'##################################################
Public Property Get pOption_Hour1() As Integer

    'Return the hours
    Let pOption_Hour1 = m_iOption_Hour1

End Property
'###########
Public Property Let pOption_Hour1(ByVal iNewValue As Integer)

    'Check the new value
    If (iNewValue < 0) Or (iNewValue > 23) Then iNewValue = 0

    'Set the new hours value
    Let m_iOption_Hour1 = iNewValue

End Property
'##################################################
Public Property Get pOption_Hour2() As Integer

    'Return the hours
    Let pOption_Hour2 = m_iOption_Hour2

End Property
'###########
Public Property Let pOption_Hour2(ByVal iNewValue As Integer)

    'Check the new value
    If (iNewValue < 0) Or (iNewValue > 23) Then iNewValue = 0

    'Set the new hours value
    Let m_iOption_Hour2 = iNewValue

End Property
'##################################################
Public Property Get pOption_MailAddress() As String

    'Return the minutes
    Let pOption_MailAddress = m_sOption_MailAddress

End Property
'###########
Public Property Let pOption_MailAddress(ByVal sNewValue As String)

    'Set the new minutes value
    Let m_sOption_MailAddress = sNewValue

End Property
'##################################################
Public Property Get pOption_Minute1() As Integer

    'Return the minutes
    Let pOption_Minute1 = m_iOption_Minute1

End Property
'###########
Public Property Let pOption_Minute1(ByVal iNewValue As Integer)

    'Check the new value
    If (iNewValue < 0) Or (iNewValue > 59) Then iNewValue = 0

    'Set the new minutes value
    Let m_iOption_Minute1 = iNewValue

End Property
'##################################################
Public Property Get pOption_Minute2() As Integer

    'Return the minutes
    Let pOption_Minute2 = m_iOption_Minute2

End Property
'###########
Public Property Let pOption_Minute2(ByVal iNewValue As Integer)

    'Check the new value
    If (iNewValue < 0) Or (iNewValue > 59) Then iNewValue = 0

    'Set the new minutes value
    Let m_iOption_Minute2 = iNewValue

End Property
'##################################################
Public Property Get pOption_ModePause() As Boolean

    'Return the version
    Let pOption_ModePause = m_bOption_ModePause

End Property
'###########
Public Property Let pOption_ModePause(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_ModePause = bNewValue

End Property
'##################################################
Public Property Get pOption_PlayerIndex() As Long

    'Return the version
    Let pOption_PlayerIndex = m_lOption_PlayerIndex

End Property
'###########
Public Property Let pOption_PlayerIndex(ByVal lNewValue As Long)

    'Set the new version value
    Let m_lOption_PlayerIndex = lNewValue

End Property
'##################################################
Public Property Get pOption_RunOnce() As Boolean

    'Return the version
    Let pOption_RunOnce = m_bOption_RunOnce

End Property
'###########
Public Property Let pOption_RunOnce(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_RunOnce = bNewValue

End Property
'##################################################
Public Property Get pOption_SendMail() As Boolean

    'Return the version
    Let pOption_SendMail = m_bOption_SendMail

End Property
'###########
Public Property Let pOption_SendMail(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_SendMail = bNewValue

End Property
'##################################################
Public Property Get pOption_ShowEndInfo() As Boolean

    'Return the version
    Let pOption_ShowEndInfo = m_bOption_ShowEndInfo

End Property
'###########
Public Property Let pOption_ShowEndInfo(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_ShowEndInfo = bNewValue

End Property
'##################################################
Public Property Get pOption_ShowErrorInfo() As Boolean

    'Return the version
    Let pOption_ShowErrorInfo = m_bOption_ShowErrorInfo

End Property
'###########
Public Property Let pOption_ShowErrorInfo(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_ShowErrorInfo = bNewValue

End Property
'##################################################
Public Property Get pOption_ShowTrayInfo() As Boolean

    'Return the version
    Let pOption_ShowTrayInfo = m_bOption_ShowTrayInfo

End Property
'###########
Public Property Let pOption_ShowTrayInfo(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_ShowTrayInfo = bNewValue

End Property
'##################################################
Public Property Get pOption_ShutDown() As Boolean

    'Return the version
    Let pOption_ShutDown = m_bOption_ShutDown

End Property
'###########
Public Property Let pOption_ShutDown(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_ShutDown = bNewValue

End Property
'##################################################
Public Property Get pOption_StartActivate() As Boolean

    'Return the version
    Let pOption_StartActivate = m_bOption_StartActivate

End Property
'###########
Public Property Let pOption_StartActivate(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_StartActivate = bNewValue

End Property
'##################################################
Public Property Get pOption_StartToTray() As Boolean

    'Return the version
    Let pOption_StartToTray = m_bOption_StartToTray

End Property
'###########
Public Property Let pOption_StartToTray(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_StartToTray = bNewValue

End Property
'##################################################
Public Property Get pOption_StartWithWin() As Boolean

    'Return the version
    Let pOption_StartWithWin = m_bOption_StartWithWin

End Property
'###########
Public Property Let pOption_StartWithWin(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_StartWithWin = bNewValue

End Property
'##################################################
Public Property Get pOption_SysTray() As Boolean

    'Return the version
    Let pOption_SysTray = m_bOption_SysTray

End Property
'###########
Public Property Let pOption_SysTray(ByVal bNewValue As Boolean)

    'Set the new version value
    Let m_bOption_SysTray = bNewValue

End Property
'##################################################
