VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPlayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @info   : Control WinAmp.                      #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### API
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

'### Constants
Private Const cCLASSNAME_ONEBYONE   As String = "1by1WndClass"
Private Const cCLASSNAME_JETAUDIO   As String = "COWON Jet-Audio MainWnd Class"
Private Const cCLASSNAME_SONIQUE    As String = "Sonique Window Class"
Private Const cCLASSNAME_WINAMP2X   As String = "Winamp v1.x"
Private Const cCLASSNAME_WINAMP3X   As String = "BaseWindow_RootWnd"
Private Const cCLASSNAME_WMPLAYER7X As String = "WMPlayerApp"
Private Const cCLASSNAME_WMPLAYER9X As String = "WMPlayerApp"
Private Const cVIRTUA_KEY_C         As Long = &H63
Private Const cVIRTUA_KEY_DOWN      As Long = &H28
Private Const cVIRTUA_KEY_UP        As Long = &H26

'### Constants (Defaults)
Private Const m_Def_eInfo_Player    As Long = 0

'### Constants (Sytem)
Private Const WM_CHAR               As Long = &H102
Private Const WM_COMMAND            As Long = &H111
Private Const WM_KEYDOWN            As Long = &H100
Private Const WM_KEYUP              As Long = &H101

'### Enums
Private Enum Send_Commands
    WAmp_Pause = 40046
    WAmp_Play = 40045
    WAmp_Stop = 40047
    WAmp_VolumeDown = 40059
    WAmp_VolumeUp = 40058
End Enum
'###
Public Enum Player_Name
    Unknown
    JetAudio
    MediaPlayer7x
    MediaPlayer9x
    OneByOne
    Sonique
    WinAmp2x
    WinAmp3x
End Enum

'### Variables
Private m_eInfo_Player            As Player_Name
Private m_lInfo_WndHandle         As Long



'##################################################
'###                  EVENTS                    ###
'##################################################

Private Sub Class_Initialize()
'### @info: Called if somebody create a new instance of this class

    'Set the default values
    Let m_eInfo_Player = m_Def_eInfo_Player

End Sub



'##################################################
'###                 METHODS                    ###
'##################################################

Public Sub sPause()
'### @info: Pause the player
    
'Ignore all errors
On Error Resume Next

    'Check if the window could be found
    If (fGetHandle) Then
        'Check what version is used
        Select Case (m_eInfo_Player)
            Case Player_Name.JetAudio, Player_Name.OneByOne
                'Send the message to pause the player
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, &H20, &H390001)
                Call PostMessage(m_lInfo_WndHandle, WM_CHAR, &H20, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H20, &HC0390001)
            Case Player_Name.MediaPlayer7x
                'Send the message to pause the player
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, &H18028, 0)
            Case Player_Name.MediaPlayer9x
                'Send the message to pause the player
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, &H14978, 0)
            Case Player_Name.WinAmp2x
                'Send the message to pause the player
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, CLng(Send_Commands.WAmp_Pause), 0)
            Case Player_Name.Sonique, Player_Name.WinAmp3x
                'Send the message to pause the player
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, &H43, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_CHAR, &H63, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H43, &HC02E0001)
        End Select
    End If

End Sub

Public Sub sPlay()
'### @info: Play further
    
'Ignore all errors
On Error Resume Next

    'Check if the window could be found
    If (fGetHandle) Then
        'Check what version is used
        Select Case (m_eInfo_Player)
            Case Player_Name.JetAudio, Player_Name.OneByOne
                'Send the message to play
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, &H20, &H390001)
                Call PostMessage(m_lInfo_WndHandle, WM_CHAR, &H20, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H20, &HC0390001)
            Case Player_Name.MediaPlayer7x
                'Send the message to play
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, &H18028, 0)
            Case Player_Name.MediaPlayer9x
                'Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H20, &HC0390001)
                'Send the message to play
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, &H14978, 0)
            Case Player_Name.WinAmp2x
                'Send the message to play
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, CLng(Send_Commands.WAmp_Play), 0)
            Case Player_Name.Sonique, Player_Name.WinAmp3x
                'Send the message to play
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, &H58, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_CHAR, &H78, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H58, &HC02E0001)
        End Select
    End If

End Sub

Public Sub sStop()
'### @info: Stop the player
    
'Ignore all errors
On Error Resume Next

    'Check if the window could be found
    If (fGetHandle) Then
        'Check what version is used
        Select Case (m_eInfo_Player)
            Case Player_Name.JetAudio
                'Send the message to stop the player
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, &H1B, &H10001)
                Call PostMessage(m_lInfo_WndHandle, WM_CHAR, &H1B, &H10001)
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H1B, &HC0010001)
            Case Player_Name.MediaPlayer7x
                'Send the message to stop the player
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, &H18029, 0)
            Case Player_Name.MediaPlayer9x
                'Send the message to stop the player
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, &H14979, 0)
            Case Player_Name.OneByOne
                'Send the message to pause the player
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, &H20, &H390001)
                Call PostMessage(m_lInfo_WndHandle, WM_CHAR, &H20, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H20, &HC0390001)
            Case Player_Name.WinAmp2x
                'Send the message to stop the player
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, CLng(Send_Commands.WAmp_Stop), 0)
            Case Player_Name.Sonique, Player_Name.WinAmp3x
                'Send the message to stop the player
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, &H56, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_CHAR, &H76, &H2E0001)
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, &H56, &HC02E0001)
        End Select
    End If

End Sub

Public Sub sVolume(Optional bIncrease As Boolean = True)
'### @info: In- or decrease the volume
    
'Ignore all errors
On Error Resume Next

    'Check if the window could be found
    If (fGetHandle) Then
        'Check what version is used
        Select Case (m_eInfo_Player)
            Case Player_Name.MediaPlayer7x
                'Send the message to change the volume
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, _
                    IIf(bIncrease, &H1802F, &H1830), 0)
            Case Player_Name.MediaPlayer9x
                'Send the message to change the volume
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, _
                    IIf(bIncrease, &H1497F, &H14980), 0)
            Case Player_Name.WinAmp2x
                'Send the message to change the volume
                Call PostMessage(m_lInfo_WndHandle, WM_COMMAND, _
                    IIf(bIncrease, CLng(Send_Commands.WAmp_VolumeUp), CLng(Send_Commands.WAmp_VolumeDown)), 0)
            Case Player_Name.JetAudio, Player_Name.OneByOne, Player_Name.Sonique, Player_Name.WinAmp3x
                'Send the message to change the volume
                Call PostMessage(m_lInfo_WndHandle, WM_KEYDOWN, _
                    IIf(bIncrease, &H26, &H28), IIf(bIncrease, &H1400001, &H1500001))
                Call PostMessage(m_lInfo_WndHandle, WM_KEYUP, _
                    IIf(bIncrease, &H26, &H28), IIf(bIncrease, &HC1400001, &HC1500001))
        End Select
    End If

End Sub

Private Function fGetHandle() As Boolean
'### @info: Try to get the handle of the window
    
'Ignore all errors
On Error Resume Next

    'Check what version is used
    Select Case (m_eInfo_Player)
        Case Player_Name.JetAudio
            'Search the window
            Let m_lInfo_WndHandle = FindWindow(cCLASSNAME_JETAUDIO, vbNullString)
        Case Player_Name.MediaPlayer7x
            'Search the window
            Let m_lInfo_WndHandle = FindWindow(cCLASSNAME_WMPLAYER7X, vbNullString)
        Case Player_Name.MediaPlayer9x
            'Search the window
            Let m_lInfo_WndHandle = FindWindow(cCLASSNAME_WMPLAYER9X, vbNullString)
        Case Player_Name.OneByOne
            'Search the window
            Let m_lInfo_WndHandle = FindWindow(cCLASSNAME_ONEBYONE, vbNullString)
        Case Player_Name.Sonique
            'Search the window
            Let m_lInfo_WndHandle = FindWindow(cCLASSNAME_SONIQUE, vbNullString)
        Case Player_Name.WinAmp2x
            'Search the window
            Let m_lInfo_WndHandle = FindWindow(cCLASSNAME_WINAMP2X, vbNullString)
        Case Player_Name.WinAmp3x
            'Search the window
            Let m_lInfo_WndHandle = FindWindow(cCLASSNAME_WINAMP3X, vbNullString)
    End Select

    'Return the operation's success
    fGetHandle = Not (m_lInfo_WndHandle = 0)

End Function



'##################################################
'###                PROPERTIES                  ###
'##################################################

Public Property Get pInfo_Player() As Player_Name

    'Return the version
    Let pInfo_Player = m_eInfo_Player

End Property
'###########
Public Property Let pInfo_Player(ByVal eNewValue As Player_Name)

    'Check the range
    If (eNewValue < Unknown) Or (eNewValue > WinAmp3x) Then eNewValue = Unknown

    'Set the new version value
    Let m_eInfo_Player = eNewValue

End Property
'##################################################
Public Property Get pInfo_WndHandle() As Long

    'Return window's handle
    Let pInfo_WndHandle = m_lInfo_WndHandle

End Property
'###########
Public Property Let pInfo_WndHandle(ByVal lNewValue As Long)

    'Set the new handle value
    Let m_lInfo_WndHandle = lNewValue

End Property
'##################################################
