VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @Option   : Everything with sound.             #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### API
Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long

'### Constants
Private Const SND_ALIAS     As Long = &H10000
Private Const SND_ASYNC     As Long = &H1
Private Const SND_NODEFAULT As Long = &H2

'### Enums
Public Enum System_Sound
    SystemQuestion
    SystemExclaimation
    SystemHand
    Maximize
    MenuCommand
    MenuPopup
    Minimize
    MailBeep
    Open_
    Close_
    AppGPFault
    Default
    SystemAsterisk
    RestoreUp
    RestoreDown
    SystemExit
    SystemStart
End Enum



'##################################################
'###                  EVENTS                    ###
'##################################################



'##################################################
'###                 METHODS                    ###
'##################################################

Public Sub sPlay_SystemSound(ByVal eType As System_Sound)
'### @info: Play a sound from the system theme

    'Variables
    Dim lResult As Long
    Dim sSound  As String

    'Get the system string for this sound
    Select Case (eType)
        Case 0: sSound = "SystemQuestion"
        Case 1: sSound = "SystemExclaimation"
        Case 2: sSound = "SystemHand"
        Case 3: sSound = "Maximize"
        Case 4: sSound = "MenuCommand"
        Case 5: sSound = "MenuPopup"
        Case 6: sSound = "Minimize"
        Case 7: sSound = "MailBeep"
        Case 8: sSound = "Open"
        Case 9: sSound = "Close"
        Case 10: sSound = "AppGPFault"
        Case 11: sSound = ".Default"
        Case 12: sSound = "SystemAsterisk"
        Case 13: sSound = "RestoreUp"
        Case 14: sSound = "RestoreDown"
        Case 15: sSound = "SystemExit"
        Case 16: sSound = "SystemStart"
    End Select

    'Try to play the sound
    lResult = PlaySound(sSound, 0&, SND_ALIAS Or SND_ASYNC Or SND_NODEFAULT)

End Sub


'##################################################
'###                PROPERTIES                  ###
'##################################################
