VERSION 5.00
Begin VB.UserControl ctlBorderBar 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "ctlBorderBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @info   : A little border bar.                 #
'##################################################

'### Variables must be declared
Option Explicit


'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### Constants
Private Const cCOLOR_BRIGHT As Long = &HFFFFFF
Private Const cCOLOR_DARK   As Long = &H99A8AC



'##################################################
'###                  EVENTS                    ###
'##################################################

Private Sub UserControl_Initialize()
 
'Handles errors
On Error Resume Next
    
    'Set the background color
    Let UserControl.BackColor = cCOLOR_BRIGHT
        
    'Draw the control
    Call sPaint
    
End Sub

Private Sub UserControl_Resize()
 
'Handles errors
On Error Resume Next
    
    'Set the correct size
    Let UserControl.Height = (2 * Screen.TwipsPerPixelY)
        
    'Draw the control
    Call sPaint
    
End Sub



'##################################################
'###                 METHODS                    ###
'##################################################

Private Sub sPaint()
 
'Handles errors
On Error Resume Next
    
    'Draw the control
    UserControl.Cls
    
    'Draw the line
    UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, 0), cCOLOR_DARK
    
    'Refresh the dislpay
    UserControl.Refresh

End Sub


