VERSION 5.00
Begin VB.UserControl ctlXPFrame 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ControlContainer=   -1  'True
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "ctlXPFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @info   : Frame with XP style.                 #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### Constants (Defaults)
Private Const m_Def_bShowborder As Boolean = True
Private Const m_Def_lBarWidth   As Long = 100

'### Variables
Private m_bShowborder         As Boolean
Private m_lBarWidth           As Long



'##################################################
'###                  EVENTS                    ###
'##################################################

Private Sub UserControl_Initialize()
'### @info: Called if the control is the first time loading
    
'Ignore all errors
On Error Resume Next

    'Set the default values
    Let m_bShowborder = m_Def_bShowborder
    Let m_lBarWidth = m_Def_lBarWidth

    'Draw the control
    Call UserControl_Resize

End Sub

Private Sub UserControl_Resize()
'### @info: If the system redraw this control
        
'Ignore all errors
On Error Resume Next

    With UserControl
        'Draw the background
        UserControl.Line (0, 0)-(m_lBarWidth - IIf(m_bShowborder, -1, 0), .ScaleHeight), &HF3F8F9, BF
        UserControl.Line (m_lBarWidth - IIf(m_bShowborder, -1, 0), 0)-(.ScaleWidth, .ScaleHeight), &HFFFFFF, BF
    
        'Draw the border lines
        If (m_bShowborder) Then
            UserControl.Line (0, 0)-(.ScaleWidth - 1, 0), &H99A8AC
            UserControl.Line (0, 0)-(0, .ScaleHeight - 1), &H99A8AC
        End If
    
        'Redraw the control
        Call .Refresh
    End With

End Sub


'##################################################
'###                 METHODS                    ###
'##################################################





'##################################################
'###                PROPERTIES                  ###
'##################################################

Public Property Get pBarWidth() As Long

    'Return the hours
    Let pBarWidth = m_lBarWidth

End Property
'###########
Public Property Let pBarWidth(ByVal lNewValue As Long)

    'Set the new hours value
    Let m_lBarWidth = lNewValue
    
    'Redraw the control
    Call UserControl_Resize

End Property
'##################################################
Public Property Get pShowBorder() As Boolean

    'Return the hours
    Let pShowBorder = m_bShowborder

End Property
'###########
Public Property Let pShowBorder(ByVal bNewValue As Boolean)

    'Set the new hours value
    Let m_bShowborder = bNewValue
    
    'Redraw the control
    Call UserControl_Resize

End Property
'##################################################

