Attribute VB_Name = "modMain"
'##################################################
'# @author : Matthias Bartelt                     #
'# @version: 0.0                                  #
'##################################################
'# @info   : Main module with the main methods.   #
'##################################################

'### Variables must be declared
Option Explicit



'##################################################
'###              DECLARATIONS                  ###
'##################################################

'### API
Private Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

'### Classes
Public CEvents                       As Collection
Public CInternet                     As clsInternet
Public COption                       As clsOption
Public CPlayer                       As clsPlayer
Public CSound                        As clsSound
Public CSystem                       As clsSystem

'### Constants
Public Const cFOLDER_PROFILES        As String = "\profiles"

'### Constants (System)
Private Const SEM_NOGPFAULTERRORBOX  As Long = &H2&



'##################################################
'###                 METHODS                    ###
'##################################################

Private Sub Main()
'### @info: This is the first method call when the application is
'#          started the first time.

    'Check if there is an other app instance
    If (App.PrevInstance) Then
        'Show the info
        Call MsgBox("Das Programm wird bereits ausgefhrt. Bitte beenden Sie zuerst die andere Instanz und " & _
            "versuchen Sie dann erneut es zu ffnen.", vbInformation, "Fehler:")
        End
    End If

    'Variables
    Dim lResult   As Long
    Dim sINIValue As String

    'Create new class instances/collections
    Set CEvents = New Collection
    Set CInternet = New clsInternet
    Set COption = New clsOption
    Set CPlayer = New clsPlayer
    Set CSound = New clsSound
    Set CSystem = New clsSystem

'Process the error
On Error GoTo errError

    'Load the options
    Call COption.sSettings_Load

    'Check the program folders
    Call sCheckFolders

    'Set the XP design
    Call InitCommonControls

    'Load the main form and show it
    Call Load(frmMain): Call frmMain.sInit
    
    Exit Sub

'If an error occured
errError:
'Display the error
Call frmError.sError(CLng(Err.Number), CStr(Err.Description), "modMain:Main")
Resume Next

End Sub

Private Sub sCheckFolders()
'### @info: Check the program folders

'Process the error
On Error GoTo errError

    'Check if the profile folder exist (if not - create it)
    If Not (CSystem.fDirExist(App.Path & cFOLDER_PROFILES)) Then _
        Call MkDir(App.Path & cFOLDER_PROFILES)

    Exit Sub

'If an error occured
errError:
'Should the error be displayed
If (COption.pOption_ShowErrorInfo) Then _
    Call frmError.sError(CLng(Err.Number), CStr(Err.Description), "modMain:sCheckFolders")
Resume Next

End Sub

Public Sub sExitApp()
'### @info: Close the application and destroy all objects and free
'#          up the memory

'Process the error
On Error GoTo errError

    'Variables
    Dim CTimeEvent As clsTimeEvent

    'Remove each item from the collection
    If (CEvents.Count > 0) Then
        For Each CTimeEvent In CEvents
            'Revmote it
            Set CTimeEvent = Nothing
        Next
    End If

    'Remove the objects
    If Not (CEvents Is Nothing) Then Set CEvents = Nothing
    If Not (CInternet Is Nothing) Then Set CInternet = Nothing
    If Not (COption Is Nothing) Then Set COption = Nothing
    If Not (CPlayer Is Nothing) Then Set CPlayer = Nothing
    If Not (CSound Is Nothing) Then Set CSound = Nothing
    If Not (CSystem Is Nothing) Then Set CSystem = Nothing

    'Fix the bug in XP with the manifest file (errors occured)
    Call SetErrorMode(SEM_NOGPFAULTERRORBOX)

    Exit Sub

'If an error occured
errError:

End Sub
